Text (Java SE 26 & JDK 26)
Description: declaration: module: java.xml, package: org.w3c.dom, interface: Text
Keywords: org.w3c.dom.Text interface

# Interface Text

All Superinterfaces:
  `CharacterData, Node`

All Known Subinterfaces:
  `CDATASection`

public interface Text extends CharacterData
The `Text` interface inherits from `CharacterData` and represents the textual content (termed character data in XML) of an `Element` or `Attr`. If there is no markup inside an element's content, the text is contained in a single object implementing the `Text` interface that is the only child of the element. If there is markup, it is parsed into the information items (elements, comments, etc.) and `Text` nodes that form the list of children of the element.

When a document is first made available via the DOM, there is only one `Text` node for each block of text. Users may create adjacent `Text` nodes that represent the contents of a given element without any intervening markup, but should be aware that there is no way to represent the separations between these nodes in XML or HTML, so they will not (in general) persist between DOM editing sessions. The `Node.normalize()` method merges any such adjacent `Text` objects into a single node for each block of text.

No lexical check is done on the content of a `Text` node and, depending on its position in the document, some characters must be escaped during serialization using character references; e.g. the characters "<&" if the textual content is part of an element or of an attribute, the character sequence "]]>" when part of an element, the quotation mark character " or the apostrophe character ' when part of an attribute.

See also the Document Object Model (DOM) Level 3 Core Specification.

Since:
  1.4, DOM Level 2

- ## Field Summary

  ### Fields declared in interface Node

  `ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_POSITION_CONTAINED_BY, DOCUMENT_POSITION_CONTAINS, DOCUMENT_POSITION_DISCONNECTED, DOCUMENT_POSITION_FOLLOWING, DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC, DOCUMENT_POSITION_PRECEDING, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`
  Modifier and Type
  Field
  Description
  `static final short`
  `ATTRIBUTE_NODE`
  The node is an `Attr`.
  `static final short`
  `CDATA_SECTION_NODE`
  The node is a `CDATASection`.
  `static final short`
  `COMMENT_NODE`
  The node is a `Comment`.
  `static final short`
  `DOCUMENT_FRAGMENT_NODE`
  The node is a `DocumentFragment`.
  `static final short`
  `DOCUMENT_NODE`
  The node is a `Document`.
  `static final short`
  `DOCUMENT_POSITION_CONTAINED_BY`
  The node is contained by the reference node.
  `static final short`
  `DOCUMENT_POSITION_CONTAINS`
  The node contains the reference node.
  `static final short`
  `DOCUMENT_POSITION_DISCONNECTED`
  The two nodes are disconnected.
  `static final short`
  `DOCUMENT_POSITION_FOLLOWING`
  The node follows the reference node.
  `static final short`
  `DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC`
  The determination of preceding versus following is implementation-specific.
  `static final short`
  `DOCUMENT_POSITION_PRECEDING`
  The second node precedes the reference node.
  `static final short`
  `DOCUMENT_TYPE_NODE`
  The node is a `DocumentType`.
  `static final short`
  `ELEMENT_NODE`
  The node is an `Element`.
  `static final short`
  `ENTITY_NODE`
  The node is an `Entity`.
  `static final short`
  `ENTITY_REFERENCE_NODE`
  The node is an `EntityReference`.
  `static final short`
  `NOTATION_NODE`
  The node is a `Notation`.
  `static final short`
  `PROCESSING_INSTRUCTION_NODE`
  The node is a `ProcessingInstruction`.
  `static final short`
  `TEXT_NODE`
  The node is a `Text` node.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getWholeText()`
  Returns all text of `Text` nodes logically-adjacent text nodes to this node, concatenated in document order.
  `boolean`
  `isElementContentWhitespace()`
  Returns whether this text node contains element content whitespace, often abusively called "ignorable whitespace".
  `Text`
  `replaceWholeText(String content)`
  Replaces the text of the current node and all logically-adjacent text nodes with the specified text.
  `Text`
  `splitText(int offset)`
  Breaks this node into two nodes at the specified `offset`, keeping both in the tree as siblings.

  ### Methods declared in interface CharacterData

  `appendData, deleteData, getData, getLength, insertData, replaceData, setData, substringData`
  Modifier and Type
  Method
  Description
  `void`
  `appendData(String arg)`
  Append the string to the end of the character data of the node.
  `void`
  `deleteData(int offset, int count)`
  Remove a range of 16-bit units from the node.
  `String`
  `getData()`
  The character data of the node that implements this interface.
  `int`
  `getLength()`
  The number of 16-bit units that are available through `data` and the `substringData` method below.
  `void`
  `insertData(int offset, String arg)`
  Insert a string at the specified 16-bit unit offset.
  `void`
  `replaceData(int offset, int count, String arg)`
  Replace the characters starting at the specified 16-bit unit offset with the specified string.
  `void`
  `setData(String data)`
  The character data of the node that implements this interface.
  `String`
  `substringData(int offset, int count)`
  Extracts a range of data from the node.

  ### Methods declared in interface Node

  `appendChild, cloneNode, compareDocumentPosition, getAttributes, getBaseURI, getChildNodes, getFeature, getFirstChild, getLastChild, getLocalName, getNamespaceURI, getNextSibling, getNodeName, getNodeType, getNodeValue, getOwnerDocument, getParentNode, getPrefix, getPreviousSibling, getTextContent, getUserData, hasAttributes, hasChildNodes, insertBefore, isDefaultNamespace, isEqualNode, isSameNode, isSupported, lookupNamespaceURI, lookupPrefix, normalize, removeChild, replaceChild, setNodeValue, setPrefix, setTextContent, setUserData`
  Modifier and Type
  Method
  Description
  `Node`
  `appendChild(Node newChild)`
  Adds the node `newChild` to the end of the list of children of this node.
  `Node`
  `cloneNode(boolean deep)`
  Returns a duplicate of this node, i.e., serves as a generic copy constructor for nodes.
  `short`
  `compareDocumentPosition(Node other)`
  Compares the reference node, i.e. the node on which this method is being called, with a node, i.e. the one passed as a parameter, with regard to their position in the document and according to the document order.
  `NamedNodeMap`
  `getAttributes()`
  A `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise.
  `String`
  `getBaseURI()`
  The absolute base URI of this node or `null` if the implementation wasn't able to obtain an absolute URI.
  `NodeList`
  `getChildNodes()`
  A `NodeList` that contains all children of this node.
  `Object`
  `getFeature(String feature, String version)`
  This method returns a specialized object which implements the specialized APIs of the specified feature and version, as specified in .
  `Node`
  `getFirstChild()`
  The first child of this node.
  `Node`
  `getLastChild()`
  The last child of this node.
  `String`
  `getLocalName()`
  Returns the local part of the qualified name of this node.
  `String`
  `getNamespaceURI()`
  The namespace URI of this node, or `null` if it is unspecified (see ).
  `Node`
  `getNextSibling()`
  The node immediately following this node.
  `String`
  `getNodeName()`
  The name of this node, depending on its type; see the table above.
  `short`
  `getNodeType()`
  A code representing the type of the underlying object, as defined above.
  `String`
  `getNodeValue()`
  The value of this node, depending on its type; see the table above.
  `Document`
  `getOwnerDocument()`
  The `Document` object associated with this node.
  `Node`
  `getParentNode()`
  The parent of this node.
  `String`
  `getPrefix()`
  The namespace prefix of this node, or `null` if it is unspecified.
  `Node`
  `getPreviousSibling()`
  The node immediately preceding this node.
  `String`
  `getTextContent()`
  This attribute returns the text content of this node and its descendants.
  `Object`
  `getUserData(String key)`
  Retrieves the object associated to a key on a this node.
  `boolean`
  `hasAttributes()`
  Returns whether this node (if it is an element) has any attributes.
  `boolean`
  `hasChildNodes()`
  Returns whether this node has any children.
  `Node`
  `insertBefore(Node newChild, Node refChild)`
  Inserts the node `newChild` before the existing child node `refChild`.
  `boolean`
  `isDefaultNamespace(String namespaceURI)`
  This method checks if the specified `namespaceURI` is the default namespace or not.
  `boolean`
  `isEqualNode(Node arg)`
  Tests whether two nodes are equal.
  `boolean`
  `isSameNode(Node other)`
  Returns whether this node is the same node as the given one.
  `boolean`
  `isSupported(String feature, String version)`
  Tests whether the DOM implementation implements a specific feature and that feature is supported by this node, as specified in .
  `String`
  `lookupNamespaceURI(String prefix)`
  Look up the namespace URI associated to the given prefix, starting from this node.
  `String`
  `lookupPrefix(String namespaceURI)`
  Look up the prefix associated to the given namespace URI, starting from this node.
  `void`
  `normalize()`
  Puts all `Text` nodes in the full depth of the sub-tree underneath this `Node`, including attribute nodes, into a "normal" form where only structure (e.g., elements, comments, processing instructions, CDATA sections, and entity references) separates `Text` nodes, i.e., there are neither adjacent `Text` nodes nor empty `Text` nodes.
  `Node`
  `removeChild(Node oldChild)`
  Removes the child node indicated by `oldChild` from the list of children, and returns it.
  `Node`
  `replaceChild(Node newChild, Node oldChild)`
  Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node.
  `void`
  `setNodeValue(String nodeValue)`
  The value of this node, depending on its type; see the table above.
  `void`
  `setPrefix(String prefix)`
  The namespace prefix of this node, or `null` if it is unspecified.
  `void`
  `setTextContent(String textContent)`
  This attribute returns the text content of this node and its descendants.
  `Object`
  `setUserData(String key, Object data, UserDataHandler handler)`
  Associate an object to a key on this node.

- ## Method Details

  - ### splitText

    Text splitText(int offset) throws DOMException
    Breaks this node into two nodes at the specified `offset`, keeping both in the tree as siblings. After being split, this node will contain all the content up to the `offset` point. A new node of the same type, which contains all the content at and after the `offset` point, is returned. If the original node had a parent node, the new node is inserted as the next sibling of the original node. When the `offset` is equal to the length of this node, the new node has no data.
    Parameters:
      `offset` - The 16-bit unit offset at which to split, starting from `0`.
    Returns:
      The new node, of the same type as this node.
    Throws:
      `DOMException` - INDEX_SIZE_ERR: Raised if the specified offset is negative or greater than the number of 16-bit units in `data`.
      NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

  - ### isElementContentWhitespace

    boolean isElementContentWhitespace()
    Returns whether this text node contains element content whitespace, often abusively called "ignorable whitespace". The text node is determined to contain whitespace in element content during the load of the document or if validation occurs while using `Document.normalizeDocument()`.
    Since:
      1.5, DOM Level 3

  - ### getWholeText

    String getWholeText()
    Returns all text of `Text` nodes logically-adjacent text nodes to this node, concatenated in document order.
    For instance, in the example below `wholeText` on the `Text` node that contains "bar" returns "barfoo", while on the `Text` node that contains "foo" it returns "barfoo".

                            +-----+
                            | <p> |
                            +-----+
                              /\
                             /  \
                      /-----\    +-------+
                      | bar |    | &ent; |
                      \-----/    +-------+
                                     |
                                     |
                                  /-----\
                                  | foo |
                                  \-----/

    Figure: barTextNode.wholeText value is "barfoo"
    Since:
      1.5, DOM Level 3

  - ### replaceWholeText

    Text replaceWholeText(String content) throws DOMException
    Replaces the text of the current node and all logically-adjacent text nodes with the specified text. All logically-adjacent text nodes are removed including the current node unless it was the recipient of the replacement text.

    This method returns the node which received the replacement text. The returned node is:

    - `null`, when the replacement text is the empty string;
    - the current node, except when the current node is read-only;
    - a new `Text` node of the same type ( `Text` or `CDATASection`) as the current node inserted at the location of the replacement.

    For instance, in the above example calling `replaceWholeText` on the `Text` node that contains "bar" with "yo" in argument results in the following:

                            +-----+
                            | <p> |
                            +-----+
                               |
                               |
                            /-----\
                            | yo  |
                            \-----/

    Figure: barTextNode.replaceWholeText("yo") modifies the textual content of barTextNode with "yo"

    Where the nodes to be removed are read-only descendants of an `EntityReference`, the `EntityReference` must be removed instead of the read-only nodes. If any `EntityReference` to be removed has descendants that are not `EntityReference`, `Text`, or `CDATASection` nodes, the `replaceWholeText` method must fail before performing any modification of the document, raising a `DOMException` with the code `NO_MODIFICATION_ALLOWED_ERR`.

    For instance, in the example below calling `replaceWholeText` on the `Text` node that contains "bar" fails, because the `EntityReference` node "ent" contains an `Element` node which cannot be removed.

    Parameters:
      `content` - The content of the replacing `Text` node.
    Returns:
      The `Text` node created with the specified content.
    Throws:
      `DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised if one of the `Text` nodes being replaced is readonly.
    Since:
      1.5, DOM Level 3